(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*               Pierre Weis, projet Cristal, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 2001 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the Q Public License version 1.0.               *)
(*                                                                     *)
(***********************************************************************)

(* The interactive additionner program.

Compile using:
 ocamlc -I +camltk -c addition.ml
Link using:
 ocamlc -I +camltk -custom camltk.cma  addition.cmo -o addition

Try with ./addition
*)

open Tk;;

let main_window = openTk ();;

(* Labels. *)
let operation = Label.create main_window [Text "+"];;
let result_sign = Label.create main_window [Text "="];;
let result = Label.create main_window [];;

(* Entries. *)
let first_operand =
  Entry.create main_window [TextWidth 6; Relief Sunken];;
let second_operand =
  Entry.create main_window [TextWidth 6 ; Relief Sunken];;

(* References that contains the values of variables of the program. *)
let x = ref 0
and y = ref 0;;

(* Refresh result *)
let refresh_result () =
  Label.configure result [Text (string_of_int (!x + !y))];;

(* Electric *)
let get_numbers_and_refresh (entry, r) _ _ =
  try
   r := int_of_string (Entry.get entry);
   refresh_result ()
  with
  | Failure "int_of_string" ->
      Label.configure result [Text "error"];;

(* Set the callbacks *)
Entry.configure first_operand
 [XScrollCommand (get_numbers_and_refresh (first_operand, x))];
Entry.configure second_operand
 [XScrollCommand (get_numbers_and_refresh (second_operand, y))];;

let quit_button =
  Button.create main_window
    [Text "Quit"; Command closeTk];;

(* Map the widgets *)
pack
 [first_operand; operation; second_operand; result_sign; result]
 [Side Side_Left];
pack [quit_button] [];

(* Make the window resizable *)
Wm.minsize_set main_window 1 1;

(* Start interaction (event-driven program) *)
mainLoop ();;
