open Tk;;
let main_window = openTk ();;

let make_scale_255 wid name =
  Scale.create wid
    [Label name; From 0.0; To 255.0;
     Length (Centimeters 10.0); Orient Horizontal];;

let configure_scale sc c =
  Scale.configure sc [Background c];;

let red, green, blue =
 make_scale_255 main_window "Red",
 make_scale_255 main_window "Green",
 make_scale_255 main_window "Blue";;

let pattern =
  Frame.create main_window
  [Height(Centimeters 1.5); Width(Centimeters 6.0)];;

let quit =
  Button.create main_window
   [Text "Quit"; Command closeTk];;

let get_color () =
  let r = int_of_float (Scale.get red)
  and g = int_of_float (Scale.get green)
  and b = int_of_float (Scale.get blue) in
  Printf.sprintf "#%02x%02x%02x" r g b;;

let set_color _ =
  let color = get_color () in
  Frame.configure pattern [Background (NamedColor color)];;

let scales = [red; green; blue];;

let configure_scale sc =
  Scale.configure sc [ScaleCommand set_color];;
 
List.iter configure_scale scales;

pack scales [Side Side_Top];
pack [quit] [Side Side_Bottom];
pack [pattern] [Side Side_Bottom; PadY(Millimeters 2.0)];
mainLoop ();;
